Attribute VB_Name = "CalculPosition"
Option Explicit

'Public Const Pi = 3.14159265358979
Public PI As Double
Public RADTODEG As Double
Public DEGTORAD As Double

Public Const INFINITY As Double = 9E+99

' calcul suivant IJK+lg_outil

Function CalculSuivantIJK(Pt As Point3, VecteurIJK As Point3, LG_Outil As Double) As Point3
    CalculSuivantIJK = VecAdd(Pt, VecteurIJK, LG_Outil)
End Function
'CALCUL AVEC DEC
Function Calcul_Position_Poignet(Interpo As Interpolation, Uvw As AxePositionne) As Point3
Dim Pt As Point3
Dim VectIJK As Point3
Dim LG_poignet As Double

  ' Calcul de la position du point poignet
  LG_poignet = Machine.LG_Outil_Courant + Longueur(Machine.Element(6).Origine)
  VectIJK.X = Interpo.Pos.I
  VectIJK.Y = Interpo.Pos.J
  VectIJK.Z = Interpo.Pos.K
  'normalisation vecteur VectIJK
  Pt = CalculSuivantIJK(Interpo.Coord, VecteurUnitaire(VectIJK), LG_poignet)
  Debug.Print " Pt   | " & Format(Pt.X, "#,###0.0000") & " | " & Format(Pt.Y, "#,###0.0000") & " | " & Format(Pt.Z, "#,###0.0000") & " | "

Calcul_Position_Poignet = Pt
End Function

Function Calcul_Position(Pt_poignet As Point3, Inter As Interpolation, Uvw As AxePositionne) As position
Dim J As Integer
Dim position_calcule As position
Dim R1 As Double
Dim R2 As Double
Dim L1 As Double
Dim Vecteur_Proj As Point3
Dim A As Double
Dim B As Double
Dim C As Double
Dim R1A As Double
Dim R2A As Double
Dim CA As Double
Dim pt1 As Point3
Dim pt2 As Point3
Dim pt3 As Point3
Dim VY As Point3
Dim VX As Point3
Dim VZ As Point3
Dim Matr(1 To 16) As Double
Dim PtV1 As Point3
Dim PtV2 As Point3
Dim PtV3 As Point3

Dim Lg1 As Double
Dim Lg2 As Double

Dim Dist As Double
Dim Qdiff As Point3
Dim Pdiff As Point3
Dim LeVecteur As Point3
Dim Pabs As Point3
Dim PNull As Point3
Dim Y(2, 2) As Double 'Y Matrix
Dim Yangle As Double
Dim VectTrans As Point3
Dim VectTrans2 As Point3
Dim Valstck As Double

Dim PO As Point3, VPX As Point3, VPY As Point3, VPZ As Point3

For J = 0 To Machine.Element_Tripode - 1
    pt1 = VecAdd(pt1, Machine.Element(J).Origine)
Next J

PtV1 = Machine.Element(J).Pt_Tripode(1)
PtV2 = Machine.Element(J).Pt_Tripode(2)
PtV3 = Machine.Element(J).Pt_Tripode(3)




'Debug.Print " Pt_poignet   | " & Format(Pt_poignet.X, "#,###0.0000") & " | " & Format(Pt_poignet.Y, "#,###0.0000") & " | " & Format(Pt_poignet.Z, "#,###0.0000") & " | "
'Debug.Print " Pt1   | " & Format(pt1.X, "#,###0.0000") & " | " & Format(pt1.Y, "#,###0.0000") & " | " & Format(pt1.Z, "#,###0.0000") & " | "
'Debug.Print Pt_poignet.X
'Debug.Print VecSub(pt1, Pt_poignet).Z

R2 = Atan2(Sqr(VecSub(pt1, Pt_poignet).Z ^ 2 + VecSub(pt1, Pt_poignet).Y ^ 2), Pt_poignet.X) * -RADTODEG



C = Sqr(VecSub(pt1, Pt_poignet).Z ^ 2 + Sqr(Pt_poignet.X ^ 2 + Pt_poignet.Y ^ 2) ^ 2)
C = (Longueur(Machine.Element(4).Origine) + Longueur(Machine.Element(5).Origine)) - C
R1 = Atan2(VecSub(pt1, Pt_poignet).Z, Pt_poignet.Y) * RADTODEG

    'calcul R2
    
 position_calcule.Join(1) = R1
 position_calcule.Join(2) = R2
 position_calcule.Join(3) = C
 position_calcule.Join(4) = 0
 position_calcule.Join(5) = 0
' Maintenant que l'on a les 3 premiers axes
' On va calculer les vecteur orientation du poignet



Call GETPointPoignet(position_calcule, PO, VPX, VPY, VPZ, 5)

Matr(1) = VPX.X
Matr(2) = VPX.Y
Matr(3) = VPX.Z

Matr(5) = VPY.X
Matr(6) = VPY.Y
Matr(7) = VPY.Z

Matr(9) = VPZ.X
Matr(10) = VPZ.Y
Matr(11) = VPZ.Z

' Calcul des verins

PtV1 = Trans_Matrix_1_16(Matr, PtV1) 'Machine.Element(J).Pt_Tripode(1)
PtV2 = Trans_Matrix_1_16(Matr, PtV2)
PtV3 = Trans_Matrix_1_16(Matr, PtV3)

'Debug.Print " PtV1   | " & Format(PtV1.X, "#,###0.0000") & " | " & Format(PtV1.Y, "#,###0.0000") & " | " & Format(PtV1.Z, "#,###0.0000") & " | "
'Debug.Print " PtV2   | " & Format(PtV2.X, "#,###0.0000") & " | " & Format(PtV2.Y, "#,###0.0000") & " | " & Format(PtV2.Z, "#,###0.0000") & " | "

VX.X = 1
VY.Y = 1
VZ.Z = 1
'----------------
'|   Vecteur 1
'----------------
' calcul longueur sortie verin
 Pdiff = VecSub(Machine.Element(7).Origine, VecAdd(Pt_poignet, PtV1))
 CA = (Longueur(Pdiff))
 Machine.Element(9).Valeur_axe = -CA + Longueur(Machine.Element(9).Origine)


 ' projection avec VY=normale plan
 Dist = Dot(VY, Pdiff)
 Qdiff = SubVect(Pdiff, VY, Dist)
 Yangle = AngleVect(Machine.Element(9).Vecteur, Qdiff, VY)
 Machine.Element(7).Valeur_axe = Yangle
Yangle = Yangle * DEGTORAD
   
' projection avec VPX=normale plan
' Dist = Dot(VX, Pdiff)
' Qdiff = SubVect(Pdiff, VX, Dist)
' Machine.Element(8).Valeur_axe = AngleVect(Machine.Element(9).Vecteur, Qdiff, VX)
 
 
     ' Autour de Y
    '  cos(Yan)     0       sin(Yan)   
    '                                  
    '   0           1           0      
    '                                  
    ' -sin(Yan)     0       cos(Yan)   
    Y(0, 0) = Cos(Yangle) 'Y matrice
    Y(2, 2) = Cos(Yangle)
    Y(0, 2) = Sin(Yangle)
    Y(2, 0) = -Sin(Yangle)
    Y(1, 1) = 1

 VectTrans = Trans_Matrix(Y, PNull, VX)
 VectTrans2 = Trans_Matrix(Y, PNull, VZ)
 'Debug.Print " VectTrans   | " & Format(VectTrans.X, "#,###0.0000") & " | " & Format(VectTrans.Y, "#,###0.0000") & " | " & Format(VectTrans.Z, "#,###0.0000") & " | "
 'Debug.Print " VectTrans2   | " & Format(VectTrans2.X, "#,###0.0000") & " | " & Format(VectTrans2.Y, "#,###0.0000") & " | " & Format(VectTrans2.Z, "#,###0.0000") & " | "
 
  
 Dist = Dot(VectTrans, Pdiff)
 Qdiff = SubVect(Pdiff, VectTrans, Dist)
 Machine.Element(8).Valeur_axe = AngleVect(VectTrans2, Qdiff, VectTrans)
 
 
 
 
 
'----------------
'|   Vecteur 2
'----------------
' calcul longueur sortie verin
 Pdiff = VecSub(Machine.Element(10).Origine, VecAdd(Pt_poignet, PtV2))
 CA = (Longueur(Pdiff))
 Machine.Element(12).Valeur_axe = -CA + Longueur(Machine.Element(12).Origine)


 ' projection avec VY=normale plan
 Dist = Dot(VY, Pdiff)
 Qdiff = SubVect(Pdiff, VY, Dist)
 Yangle = AngleVect(Machine.Element(12).Vecteur, Qdiff, VY)
 Machine.Element(10).Valeur_axe = Yangle
  Yangle = Yangle * DEGTORAD
' projection avec VPX=normale plan
' Dist = Dot(VX, Pdiff)
' Qdiff = SubVect(Pdiff, VX, Dist)
' Machine.Element(8).Valeur_axe = AngleVect(Machine.Element(9).Vecteur, Qdiff, VX)
 
 
     ' Autour de Y
    '  cos(Yan)     0       sin(Yan)   
    '                                  
    '   0           1           0      
    '                                  
    ' -sin(Yan)     0       cos(Yan)   
    Y(0, 0) = Cos(Yangle) 'Y matrice
    Y(2, 2) = Cos(Yangle)
    Y(0, 2) = Sin(Yangle)
    Y(2, 0) = -Sin(Yangle)
    Y(1, 1) = 1

 VectTrans = Trans_Matrix(Y, PNull, VX)
 VectTrans2 = Trans_Matrix(Y, PNull, VZ)
 'Debug.Print " VectTrans   | " & Format(VectTrans.X, "#,###0.0000") & " | " & Format(VectTrans.Y, "#,###0.0000") & " | " & Format(VectTrans.Z, "#,###0.0000") & " | "
 'Debug.Print " VectTrans2   | " & Format(VectTrans2.X, "#,###0.0000") & " | " & Format(VectTrans2.Y, "#,###0.0000") & " | " & Format(VectTrans2.Z, "#,###0.0000") & " | "
 
  
 Dist = Dot(VectTrans, Pdiff)
 Qdiff = SubVect(Pdiff, VectTrans, Dist)
 Machine.Element(11).Valeur_axe = AngleVect(VectTrans2, Qdiff, VectTrans)


'----------------
'|   Vecteur 3
'----------------
' calcul longueur sortie verin
 Pdiff = VecSub(Machine.Element(13).Origine, VecAdd(Pt_poignet, PtV3))
 CA = (Longueur(Pdiff))
 Machine.Element(15).Valeur_axe = -CA + Longueur(Machine.Element(15).Origine)


 ' projection avec VY=normale plan
 Dist = Dot(VY, Pdiff)
 Qdiff = SubVect(Pdiff, VY, Dist)
 Yangle = AngleVect(Machine.Element(15).Vecteur, Qdiff, VY)
 Machine.Element(13).Valeur_axe = Yangle
  Yangle = Yangle * DEGTORAD
' projection avec VPX=normale plan
' Dist = Dot(VX, Pdiff)
' Qdiff = SubVect(Pdiff, VX, Dist)
' Machine.Element(8).Valeur_axe = AngleVect(Machine.Element(9).Vecteur, Qdiff, VX)
 
 
     ' Autour de Y
    '  cos(Yan)     0       sin(Yan)   
    '                                  
    '   0           1           0      
    '                                  
    ' -sin(Yan)     0       cos(Yan)   
    Y(0, 0) = Cos(Yangle) 'Y matrice
    Y(2, 2) = Cos(Yangle)
    Y(0, 2) = Sin(Yangle)
    Y(2, 0) = -Sin(Yangle)
    Y(1, 1) = 1

 VectTrans = Trans_Matrix(Y, PNull, VX)
 VectTrans2 = Trans_Matrix(Y, PNull, VZ)
 'Debug.Print " VectTrans   | " & Format(VectTrans.X, "#,###0.0000") & " | " & Format(VectTrans.Y, "#,###0.0000") & " | " & Format(VectTrans.Z, "#,###0.0000") & " | "
 'Debug.Print " VectTrans2   | " & Format(VectTrans2.X, "#,###0.0000") & " | " & Format(VectTrans2.Y, "#,###0.0000") & " | " & Format(VectTrans2.Z, "#,###0.0000") & " | "
 
  
 Dist = Dot(VectTrans, Pdiff)
 Qdiff = SubVect(Pdiff, VectTrans, Dist)
 Machine.Element(14).Valeur_axe = AngleVect(VectTrans2, Qdiff, VectTrans)

'Debug.Print " Pt_poignet   | " & Format(Pt_poignet.X, "#,###0.0000") & " | " & Format(Pt_poignet.Y, "#,###0.0000") & " | " & Format(Pt_poignet.Z, "#,###0.0000") & " | "
'Debug.Print " PO   | " & Format(PO.X, "#,###0.0000") & " | " & Format(PO.Y, "#,###0.0000") & " | " & Format(PO.Z, "#,###0.0000") & " | "


'----------------
'|   Join 4
'|     Axe C
'----------------
'-------------------------------
' Vecteur du join4 en position 0
Pdiff.X = Inter.Pos.I
Pdiff.Y = Inter.Pos.J
Pdiff.Z = Inter.Pos.K


' projection de LeVecteur sur le plan
 Dist = Dot(VPZ, Pdiff)
 
' projection avec VPX=normale plan
 Qdiff = SubVect(Pdiff, VPZ, Dist)
    
'Debug.Print " VPY         | " & Format(VPY.X, "#,###0.0000") & " | " & Format(VPY.Y, "#,###0.0000") & " | " & Format(VPY.Z, "#,###0.0000") & " | "
'Debug.Print " VPZ         | " & Format(VPZ.X, "#,###0.0000") & " | " & Format(VPZ.Y, "#,###0.0000") & " | " & Format(VPZ.Z, "#,###0.0000") & " | "
'Debug.Print " Qdiff       | " & Format(Qdiff.X, "#,###0.0000") & " | " & Format(Qdiff.Y, "#,###0.0000") & " | " & Format(Qdiff.Z, "#,###0.0000") & " | "
Valstck = AngleVect(VPY, Qdiff, VPZ)

Select Case Sgn(Valstck)
Case 1
    position_calcule.Join(4) = Valstck
Case -1
    position_calcule.Join(4) = 360 + Valstck
End Select



Call GETPointPoignet(position_calcule, PO, VPX, VPY, VPZ, 5)

'----------------
'|   Join 5
'|     Axe A
'----------------

' Vecteur du join4 en position 0
 Dist = Dot(VPX, Pdiff)
' projection avec VPX=normale plan
 Qdiff = SubVect(Pdiff, VPX, Dist)

'Debug.Print " VPX         | " & Format(VPX.X, "#,###0.0000") & " | " & Format(VPX.Y, "#,###0.0000") & " | " & Format(VPX.Z, "#,###0.0000") & " | "
'Debug.Print " VPY         | " & Format(VPY.X, "#,###0.0000") & " | " & Format(VPY.Y, "#,###0.0000") & " | " & Format(VPY.Z, "#,###0.0000") & " | "
'Debug.Print " VPZ         | " & Format(VPZ.X, "#,###0.0000") & " | " & Format(VPZ.Y, "#,###0.0000") & " | " & Format(VPZ.Z, "#,###0.0000") & " | "
'Debug.Print " Qdiff       | " & Format(Qdiff.X, "#,###0.0000") & " | " & Format(Qdiff.Y, "#,###0.0000") & " | " & Format(Qdiff.Z, "#,###0.0000") & " | "
'VPX = Normal au plan
position_calcule.Join(5) = AngleVect(VPZ, Qdiff, VPX)


    ' Affectation des axes optionnels
    For J = 1 To Machine.NB_axe
            Select Case Machine.Element(J).Name
                   ' Affectation des axes optionnels
                   ' Les axes optionnels doivent prendre obligatoirement la valeur de la consigne
                    Case "U"
                        position_calcule.Join(J) = Uvw.U
                    Case "V"
                        position_calcule.Join(J) = Uvw.V
                    Case "W"
                        position_calcule.Join(J) = Uvw.W
                    Case Else
                    
            End Select
    Next J
    
    
    
Calcul_Position = position_calcule
End Function

Function Position_Machine(xyz_ijk As Interpolation, u_v_w As AxePositionne) As position
Dim Point_poignet As Point3
Dim J As Integer
Dim SVG_position As position
Dim retour As Boolean

'Recalcul avec origine programme
' Decalage fix dans la fenetre FRM_simul
xyz_ijk = TransCoord(xyz_ijk)
   
Debug.Print " xyz_ijk.Coord   | " & Format(xyz_ijk.Coord.X, "#,###0.0000") & " | " & Format(xyz_ijk.Coord.Y, "#,###0.0000") & " | " & Format(xyz_ijk.Coord.Z, "#,###0.0000") & " | "
   
   
'Calcul Selon Decalage et RTCP (ou correction Lg Outil)
'Attention dans cette fonction les valeurs axes machines sont modifies
Point_poignet = Calcul_Position_Poignet(xyz_ijk, u_v_w)

' Une fois la position a atteindre calcule
' Calcul Des axes machines
' et affectation de Position_suivante
Position_Machine = Calcul_Position(Point_poignet, xyz_ijk, u_v_w)

End Function


Function Trans_Matrix(Mx2() As Double, P0 As Point3, P1 As Point3) As Point3
'Calcul suivant la  matrice de transformation
               Trans_Matrix.X = Mx2(0, 0) * P1.X + Mx2(0, 1) * P1.Y + Mx2(0, 2) * P1.Z + P0.X
               Trans_Matrix.Y = Mx2(1, 0) * P1.X + Mx2(1, 1) * P1.Y + Mx2(1, 2) * P1.Z + P0.Y
               Trans_Matrix.Z = Mx2(2, 0) * P1.X + Mx2(2, 1) * P1.Y + Mx2(2, 2) * P1.Z + P0.Z
End Function


Function Trans_Matrix_1_16(ByRef Matrix() As Double, ByRef P1 As Point3) As Point3
'Calcul suivant la  matrice de transformation
               Trans_Matrix_1_16.X = Matrix(1) * P1.X + Matrix(5) * P1.Y + Matrix(9) * P1.Z + Matrix(13)
               Trans_Matrix_1_16.Y = Matrix(2) * P1.X + Matrix(6) * P1.Y + Matrix(10) * P1.Z + Matrix(14)
               Trans_Matrix_1_16.Z = Matrix(3) * P1.X + Matrix(7) * P1.Y + Matrix(11) * P1.Z + Matrix(15)
End Function
