Attribute VB_Name = "Machine_SIMUL"
Option Explicit

' Stock du Nom du fichier ISO
Public FichierIso As String
' Stock du Nom du fichier PIECE STL
Public FichierStl As String

Public GraphPoints(0 To 99, 1 To 5) As Long
Sub DrawUsage(lUsage() As Long, ColorLigne() As Long, picGraph As PictureBox)
    Dim Cnt As Long
    Dim I As Integer
    
    DecalePoints
    For I = 1 To 5
        GraphPoints(UBound(GraphPoints), I) = lUsage(I)
    Next I
       
    picGraph.Cls
    
    For Cnt = LBound(GraphPoints) To UBound(GraphPoints) - 1
    
        ' l'affichage se fait invers car je veux avoir les axes des vrins au premier plan
        For I = 5 To 1 Step -1
                    picGraph.Line (Cnt, 100 - GraphPoints(Cnt, I))-(Cnt + 1, 100 - GraphPoints((Cnt + 1), I)), ColorLigne(I) ' &H8000&

        Next I
    Next Cnt
End Sub
'Decale tous les points d'une place vers la gauche
Sub DecalePoints()
Dim I As Integer
Dim Cnt As Long
    
    For Cnt = LBound(GraphPoints) To UBound(GraphPoints) - 1
        For I = 1 To 5
            GraphPoints(Cnt, I) = GraphPoints(Cnt + 1, I)
        Next I
    Next Cnt
End Sub
' Affiche la Position obtenues
Sub Affiche_Axes_Tripode()
Dim Color(1 To 5) As Long
Dim Percent(1 To 5) As Long
Dim I As Integer
Dim Ind As Integer


For I = 1 To 3
    Color(I) = TRIPOD_SIMUL_FRM.AxeMachine(I).BackColor
    Ind = 6 + 3 * I
    Percent(I) = ((Machine.Element(Ind).Valeur_axe - Machine.Element(Ind).MiniAxe) / (Machine.Element(Ind).MaxiAxe - Machine.Element(Ind).MiniAxe)) * 100
    TRIPOD_SIMUL_FRM.AxeMachine(I).Text = Machine.Element(Ind).Valeur_axe ' Verin I
Next I

    'TRIPOD_SIMUL_FRM.AxeMachine(1).Text = Machine.Element(9).Valeur_axe ' Verin 1
    'TRIPOD_SIMUL_FRM.AxeMachine(2).Text = Machine.Element(12).Valeur_axe ' Verin 2
    'TRIPOD_SIMUL_FRM.AxeMachine(3).Text = Machine.Element(15).Valeur_axe ' Verin 3
    'TRIPOD_SIMUL_FRM.AxeMachine(4).Text = Machine.Element(4).Valeur_axe ' Axe C
    'TRIPOD_SIMUL_FRM.AxeMachine(5).Text = Machine.Element(5).Valeur_axe 'Axe A

For I = 4 To 5
    Color(I) = TRIPOD_SIMUL_FRM.AxeMachine(I).BackColor
    Percent(I) = ((Machine.Element(I).Valeur_axe - Machine.Element(I).MiniAxe) / (Machine.Element(I).MaxiAxe - Machine.Element(I).MiniAxe)) * 100
    TRIPOD_SIMUL_FRM.AxeMachine(I).Text = Machine.Element(I).Valeur_axe
Next I
 
    DrawUsage Percent, Color, TRIPOD_SIMUL_FRM.picGraph
    
End Sub

Sub Affiche_Message(Texte As String, Optional voyant As Integer = 2)
Dim J As Integer
        For J = 1 To 2
            TRIPOD_SIMUL_FRM.PictureVoyant(J).Visible = False
        Next

        TRIPOD_SIMUL_FRM.PictureVoyant(voyant).Visible = True
        TRIPOD_SIMUL_FRM.MessageLOG.Cls
        TRIPOD_SIMUL_FRM.MessageLOG.CurrentY = 0
        TRIPOD_SIMUL_FRM.MessageLOG.Print Texte
End Sub

' Efface et rinittialise la fentre de sortie des infos
Sub MessageLOG_CLS()

    TRIPOD_SIMUL_FRM.MessageLOG.Cls
    TRIPOD_SIMUL_FRM.MessageLOG.CurrentY = 0
    
End Sub
' Ecrit dans la fenetre les infos et active un voyant
Sub MessageLOG_Print(Chaine As String, Optional voyant As Integer)

    If TRIPOD_SIMUL_FRM.MessageLOG.CurrentY >= TRIPOD_SIMUL_FRM.MessageLOG.ScaleHeight Then
        Call MessageLOG_CLS
    End If
    
    TRIPOD_SIMUL_FRM.MessageLOG.Print Chaine

    
    ' Allumage d'un voyant
    If voyant Then
       TRIPOD_SIMUL_FRM.PictureVoyant(voyant).Visible = True
    End If

End Sub

'Initialise les voyants
' 0 = Orange
' 1 = Vert
' 2 = Rouge
Sub Initialise_Voyant()
Dim J As Integer
    
    For J = 1 To 2
    TRIPOD_SIMUL_FRM.PictureVoyant(J).Visible = False
    Next
    
End Sub

Sub Allume_Voyant(voyant As Integer)

    TRIPOD_SIMUL_FRM.PictureVoyant(voyant).Visible = True

End Sub

'Execute un mouvement entre deux position XYZ AC demand
' Overtravel peremet de supprimer le test des dpassements d'axe
' Cas du chargement outil par exemple
Function Execute_Deplacement(XYZ_ABC As Interpolation, Uvw As AxePositionne, Optional OverTravel As Boolean = False) As Boolean
Dim Increment_max As Integer
Dim Increment_controle As Integer
Dim J As Integer
Dim I As Integer
Dim Ret As Boolean

Dim XyzIjk_Memoire As Interpolation
Dim Uvw_Memoire As AxePositionne

Dim xyz_ijk_lu As Interpolation
Dim Uvw_lu As AxePositionne
Dim xyz_ijk_Int As Interpolation
Dim Uvw_Int As AxePositionne

Dim Position_int As position
Dim Position_prec As position
Dim Position_suite As position


Execute_Deplacement = False
'Voyant Orange allume
Call Initialise_Voyant

'Recalcul avec origine programme
' Decalage fix dans la fenetre FRM_simul
'XyzIjk_Memoire = TransCoord(Position_Actuelle, OrigineProg)

XyzIjk_Memoire = Position_Actuelle
Uvw_Memoire = UVW_Actuelle
xyz_ijk_lu = XYZ_ABC
Uvw_lu = Uvw

'Calcul selon la position demande les valeurs des axes machines
'Sauvegarde position actuelle
For J = 1 To Machine.NB_axe + 1
    Position_prec.Join(J) = Machine.Element(J).Valeur_axe
Next
    Position_precedente = Position_prec
' Une fois la position a atteindre calcule
' Calcul Des axes machines
' et affectation de Position_suivante
Position_suite = Position_Machine(xyz_ijk_lu, Uvw_lu)



' Controle des limites sur les axes ( chargement outil fait sans controle de limite )
If OverTravel = False Then
For J = 1 To Machine.NB_axe + 1
    If Position_suite.Join(J) < Machine.Element(J).MiniAxe Or Position_suite.Join(J) > Machine.Element(J).MaxiAxe Then
        Call Affiche_Message(" Attention Axe " & J & " Hors Course")
        Call MessageLOG_Print(" Axe " & Machine.Element(J).Name & " Limit entre " & Machine.Element(J).MiniAxe & " et " & Machine.Element(J).MaxiAxe)
        Call MessageLOG_Print(" Valeur demande " & Format(Position_suite.Join(J), "# ###.###"))
        Exit Function
    End If
Next
End If

' Controle des limites sur les axes du tripode
If OverTravel = False Then
For J = 9 To 15 Step 3
    If Machine.Element(J).Valeur_axe < Machine.Element(J).MiniAxe Or Machine.Element(J).Valeur_axe > Machine.Element(J).MaxiAxe Then
        Call Affiche_Message(" Attention Axe Tripode " & J & " Hors Course")
        Call MessageLOG_Print(" Axe Tripode" & Machine.Element(J).Name & " Limit entre " & Machine.Element(J).MiniAxe & " et " & Machine.Element(J).MaxiAxe)
        Call MessageLOG_Print(" Valeur demande " & Format(Machine.Element(J).Valeur_axe, "# ###.###"))
        
        ' Va  la position Limite ce qui permet de visualiser cette position
        ' et comme les axes tripodes (Vrins) ont dj t initialis alors permet de ne pas avoir de dcalage
        ' suite a un arret sur les axes vrins
        For I = 1 To Machine.NB_axe
         Machine.Element(I).Valeur_axe = Position_suite.Join(I)
        Next
    
        Call GetPoint
        Call TRIPOD_SIMUL_FRM.Pic_Paint
        
        Exit Function
    End If
Next
End If

Increment_max = 1

'Cherche l'incrment sur les axes "Lineaire" = ceux qui provoquent les plus grands dplacements
For J = 1 To Machine.NB_axe
     If Machine.Element(J).Type_axe = 2 Then
        Increment_controle = Abs((Position_suite.Join(J) - Position_prec.Join(J))) / TRIPOD_SIMUL_FRM.SliderIncrement.Value
        If Increment_controle > Increment_max Then
           Increment_max = Increment_controle
        End If
     End If
Next
' Increment_max est toujours egal a un dans ce
' Cas il y a un mouvement uniquement sur des axes circulaires
If Increment_max = 1 Then
    For J = 1 To Machine.NB_axe
            Increment_controle = Abs((Position_suite.Join(J) - Position_prec.Join(J))) / TRIPOD_SIMUL_FRM.SliderIncrement.Value
            If Increment_controle > Increment_max Then
               Increment_max = Increment_controle
            End If
    Next
End If


For I = 1 To Increment_max '- 1
    xyz_ijk_Int.Coord.X = XyzIjk_Memoire.Coord.X + I * ((XYZ_ABC.Coord.X - XyzIjk_Memoire.Coord.X) / Increment_max)
    xyz_ijk_Int.Coord.Y = XyzIjk_Memoire.Coord.Y + I * ((XYZ_ABC.Coord.Y - XyzIjk_Memoire.Coord.Y) / Increment_max)
    xyz_ijk_Int.Coord.Z = XyzIjk_Memoire.Coord.Z + I * ((XYZ_ABC.Coord.Z - XyzIjk_Memoire.Coord.Z) / Increment_max)
    xyz_ijk_Int.Pos.I = XyzIjk_Memoire.Pos.I + I * ((XYZ_ABC.Pos.I - XyzIjk_Memoire.Pos.I) / Increment_max)
    xyz_ijk_Int.Pos.J = XyzIjk_Memoire.Pos.J + I * ((XYZ_ABC.Pos.J - XyzIjk_Memoire.Pos.J) / Increment_max)
    xyz_ijk_Int.Pos.K = XyzIjk_Memoire.Pos.K + I * ((XYZ_ABC.Pos.K - XyzIjk_Memoire.Pos.K) / Increment_max)
    
    Uvw_Int.U = Uvw_Memoire.U + I * ((Uvw.U - Uvw_Memoire.U) / Increment_max)
    Uvw_Int.V = Uvw_Memoire.V + I * ((Uvw.V - Uvw_Memoire.V) / Increment_max)
    Uvw_Int.W = Uvw_Memoire.W + I * ((Uvw.W - Uvw_Memoire.W) / Increment_max)

    ' Une fois la position a atteindre calcule
    ' Calcul Des axes machines
    ' et affectation de Position_suivante
    Position_int = Position_Machine(xyz_ijk_Int, Uvw_Int)
    

    For J = 1 To Machine.NB_axe
        Machine.Element(J).Valeur_axe = Position_int.Join(J)
    Next
    

    Call TRIPOD_SIMUL_FRM.Pic_Paint

    
' calcul la collision
    If TRIPOD_SIMUL_FRM.CheckBox Then
        If Collision Then
            ' Affiche la coordonnes obtenues
            Call Affiche_coord
            Call Affiche_Message(" Collision")
            Call TRIPOD_SIMUL_FRM.Pic_Paint
            Position_suivante = Position_int
            GoTo fin
        End If
    End If
    
Next

    'Call GetPoint
    ' Sauvegared position
    'Call Sauvegarde_Position
    'Position_Actuelle = xyz_ijk_Int
    'Permet d'annuler la simulation
    'DoEvents
    

    ' Position exacte demande
    For J = 1 To Machine.NB_axe
         Machine.Element(J).Valeur_axe = Position_suite.Join(J)
    Next
    
    Position_suivante = Position_suite


    For J = 1 To Machine.NB_axe
        Machine.Element(J).Valeur_axe = Position_int.Join(J)
    Next
    
    Position_suivante = Position_int
    
    ' calcul la collision
    If TRIPOD_SIMUL_FRM.CheckBox Then
        If Collision Then
            Call Affiche_Message(" Collision")
            Call TRIPOD_SIMUL_FRM.Pic_Paint
            GoTo fin
        End If
    End If






 'Voyant vert allum
Call Allume_Voyant(1)



Execute_Deplacement = True

fin:

Call GetPoint
Call TRIPOD_SIMUL_FRM.Pic_Paint

' Sauvegared position
Call Sauvegarde_Position
Position_Actuelle = XYZ_ABC
'Permet d'annuler la simulation
DoEvents
    
' Affiche la coordonnes obtenues
Call Affiche_coord
    
' Affiche la Position obtenues
Call Affiche_Axes_Tripode
    
XYZ_ABC.Coord = Pt0


End Function

Sub Sauvegarde_Position()
Dim I As Integer
Dim Element As Element3D

For I = 1 To UBound(Machine.Element)
    Element = Machine.Element(I)
    ' Sauvegarde position
    Select Case Element.Name
        Case "U"
              UVW_Actuelle.U = Element.Valeur_axe
        Case "V"
              UVW_Actuelle.V = Element.Valeur_axe
        Case "W"
              UVW_Actuelle.W = Element.Valeur_axe
        Case "I"
              Position_Actuelle.Pos.I = Element.Valeur_axe
        Case "J"
              Position_Actuelle.Pos.J = Element.Valeur_axe
        Case "K"
              Position_Actuelle.Pos.K = Element.Valeur_axe
    End Select
Next I


End Sub

' Sauvegarde un projet
' Machine
' Piece
' Fichier Iso
' Reglages
' Position Machine
Sub Sauver_Projet(fichier As String)
Dim Ret As Integer
Dim Chaine As String
Dim I As Integer


    'Machine
    Ret = mfncWriteIni("Machine", "Fichier_Machine", Fichier_Machine, fichier)
    
    Chaine = Machine.Outil_Courant
    Ret = mfncWriteIni("Machine", "Outil_Courant", Chaine, fichier)
    
    Chaine = ""
    'For I = 1 To Machine.Element
    'Chaine = Chaine & Machine.Element(I).Valeur_axe & ","
    'Next I
    
    Chaine = Chaine & Pt0.X & "," & Pt0.Y & "," & Pt0.Z & "," & VZ.X & "," & VZ.Y & "," & VZ.Z
    
    Ret = mfncWriteIni("Machine", "Position_Actuelle", Mid(Chaine, 1, Len(Chaine) - 1), fichier)

    
    ' Affichage depart
    Chaine = xm
    Ret = mfncWriteIni("Machine_Simu", "Xm", Chaine, fichier)
    Chaine = ym
    Ret = mfncWriteIni("Machine_Simu", "Ym", Chaine, fichier)
    Chaine = zm
    Ret = mfncWriteIni("Machine_Simu", "Zm", Chaine, fichier)
    Chaine = Zoom
    Ret = mfncWriteIni("Machine_Simu", "Zoom", Chaine, fichier)
    Chaine = PosX
    Ret = mfncWriteIni("Machine_Simu", "PosX", Chaine, fichier)
    Chaine = PosY
    Ret = mfncWriteIni("Machine_Simu", "PosY", Chaine, fichier)
    
    Chaine = TRIPOD_SIMUL_FRM.OptionTracerParcours.Value
    Ret = mfncWriteIni("Machine_Simu", "TracerParcours", Chaine, fichier)
    
    Chaine = TRIPOD_SIMUL_FRM.SliderIncrement.Value
    Ret = mfncWriteIni("Machine_Simu", "Increment", Chaine, fichier)
    
    'Lumiere
    Chaine = TRIPOD_SIMUL_FRM.sldAlpha.Value
    Ret = mfncWriteIni("Machine_Simu", "Transparence", Chaine, fichier)
    
    For I = 0 To 2
        Chaine = "Light" & I
        Ret = mfncWriteIni("Machine_Simu", Chaine, TRIPOD_SIMUL_FRM.Light(I).Text, fichier)
    Next I

    
    Chaine = TRIPOD_SIMUL_FRM.CHK.Value
    Ret = mfncWriteIni("Machine_Simu", "Grille", Chaine, fichier)
    Ret = mfncWriteIni("Machine_Simu", "ZGrille", TRIPOD_SIMUL_FRM.Zgrille.Text, fichier)
    
      
    Chaine = TRIPOD_SIMUL_FRM.CheckBox.Value
    Ret = mfncWriteIni("Machine_Simu", "Collision", Chaine, fichier)
    
    
    For I = 1 To 4
        Chaine = "AxeOrigine" & I
        Ret = mfncWriteIni("Machine_Simu", Chaine, TRIPOD_SIMUL_FRM.AxeOrigine(I).Text, fichier)
    Next I
    
    ' Piece
    
    Ret = mfncWriteIni("Piece", "Fichier_Piece", FichierStl, fichier)
    Chaine = Piece.Color.Rouge
    Ret = mfncWriteIni("Piece", "Couleur_Piece_Rouge", Chaine, fichier)
    Chaine = Piece.Color.Vert
    Ret = mfncWriteIni("Piece", "Couleur_Piece_Vert", Chaine, fichier)
    Chaine = Piece.Color.Bleu
    Ret = mfncWriteIni("Piece", "Couleur_Piece_Bleu", Chaine, fichier)
    
    'Fichier Iso
    Ret = mfncWriteIni("Iso", "Fichier_Iso", FichierIso, fichier)
    
End Sub

' Charger un projet
' Machine
' Piece
' Fichier Iso
' Reglages
' Position Machine
Sub Charger_Projet(fichier As String)
Dim Chaine As String
Dim I As Integer
Dim PtOrigine As Point3
Dim ValAxe As Double
Dim TableauPosition
Dim xyz_ijk_lu As Interpolation
Dim retour As Boolean
Dim pos_null As position

On Error Resume Next

'desactif la controle de collision pour effectuer les chragement machine et autre
TRIPOD_SIMUL_FRM.CheckBox.Value = False
    
    TRIPOD_SIMUL_FRM.CHK.Value = Val(mfncGetFromIni("Machine_Simu", "Grille", fichier))
    TRIPOD_SIMUL_FRM.Zgrille.Text = mfncGetFromIni("Machine_Simu", "ZGrille", fichier)
       
    TRIPOD_SIMUL_FRM.OptionTracerParcours.Value = Val(mfncGetFromIni("Machine_Simu", "TracerParcours", fichier))
    
    TRIPOD_SIMUL_FRM.SliderIncrement.Value = Val(mfncGetFromIni("Machine_Simu", "Increment", fichier))
    
    'Lumiere
    TRIPOD_SIMUL_FRM.sldAlpha.Value = Val(mfncGetFromIni("Machine_Simu", "Transparence", fichier))
    
    For I = 0 To 2
        Chaine = "Light" & I
        TRIPOD_SIMUL_FRM.Light(I).Text = mfncGetFromIni("Machine_Simu", Chaine, fichier)
        TRIPOD_SIMUL_FRM.HScroll(I).Value = Val(mfncGetFromIni("Machine_Simu", Chaine, fichier))
    Next I
    
    Call Lampe
    
    xm = Val(mfncGetFromIni("Machine_Simu", "Xm", fichier))
    ym = Val(mfncGetFromIni("Machine_Simu", "Ym", fichier))
    zm = Val(mfncGetFromIni("Machine_Simu", "Zm", fichier))
    Zoom = Val(mfncGetFromIni("Machine_Simu", "Zoom", fichier))
    PosX = Val(mfncGetFromIni("Machine_Simu", "PosX", fichier))
    PosY = Val(mfncGetFromIni("Machine_Simu", "PosY", fichier))
    
    
    'machine
    Fichier_Machine = mfncGetFromIni("Machine", "Fichier_Machine", fichier)
    'Debug.Print TokRightLeft(Fichier_Machine, "\")
    Call Chargement_machine(TokRightRight(TokRightLeft(Fichier_Machine, "\"), "\"), Fichier_Machine)
    Piece.Vecteur = Machine.Element(0).Vecteur
    

       
    
    
    'Debug.Print mfncGetFromIni("Machine", "Position_Actuelle", fichier)
    TableauPosition = Split(mfncGetFromIni("Machine", "Position_Actuelle", fichier), ",")
    
    'For I = 1 To UBound(TableauPosition)
     'Machine.Element(I).Valeur_axe = Val(TableauPosition(I))
    ' Position_suivante.Join(I) = Val(TableauPosition(I))
    
    'Next I
   
   'Recuperation coordonees
    xyz_ijk_lu.Coord.X = Val(TableauPosition(0))
    xyz_ijk_lu.Coord.Y = Val(TableauPosition(1))
    xyz_ijk_lu.Coord.Z = Val(TableauPosition(2))
    xyz_ijk_lu.Pos.I = Val(TableauPosition(3))
    xyz_ijk_lu.Pos.J = Val(TableauPosition(4))
    xyz_ijk_lu.Pos.K = Val(TableauPosition(5))

   Position_precedente = pos_null
   Position_suivante = pos_null
   
    ' Execute deplacement
    retour = Execute_Deplacement(xyz_ijk_lu, UVW_Actuelle)

    Call Charge_Outil(Val(mfncGetFromIni("Machine", "Outil_Courant", fichier)))
    'Machine.Outil_Courant = Val(mfncGetFromIni("Machine", "Outil_Courant", fichier))
   
     
   Call TRIPOD_SIMUL_FRM.Execute_mouvement
   

     
        'origine
    For I = 1 To 4
        Chaine = "AxeOrigine" & I
        TRIPOD_SIMUL_FRM.AxeOrigine(I).Text = mfncGetFromIni("Machine_Simu", Chaine, fichier)
    Next I
    
   'Origine programme
    PtOrigine.X = Val(TRIPOD_SIMUL_FRM.AxeOrigine(1).Text)
    PtOrigine.Y = Val(TRIPOD_SIMUL_FRM.AxeOrigine(2).Text)
    PtOrigine.Z = Val(TRIPOD_SIMUL_FRM.AxeOrigine(3).Text)
    ValAxe = Val(TRIPOD_SIMUL_FRM.AxeOrigine(4).Text)
    
    Piece.Origine.X = PtOrigine.X
    Piece.Origine.Y = PtOrigine.Y
    Piece.Origine.Z = PtOrigine.Z
    Piece.Valeur_axe = ValAxe
     
   ' active ou non le controle de collision aprs le chargement outil
   TRIPOD_SIMUL_FRM.CheckBox.Value = Val(mfncGetFromIni("Machine_Simu", "Collision", fichier))
   
   

    
    'Piece
        ' Piece
        Chaine = mfncGetFromIni("Piece", "Fichier_Piece", fichier)
        If Chaine <> "" Then
            FichierStl = Chaine
            Call Chargement_piece(FichierStl, ValAxe, PtOrigine)
            Piece.Color.Rouge = Val(mfncGetFromIni("Piece", "Couleur_Piece_Rouge", fichier))
            Piece.Color.Vert = Val(mfncGetFromIni("Piece", "Couleur_Piece_Vert", fichier))
            Piece.Color.Bleu = Val(mfncGetFromIni("Piece", "Couleur_Piece_Bleu", fichier))
        End If
        
    'Fichier ISO
        Chaine = mfncGetFromIni("Iso", "Fichier_Iso", fichier)
        If Chaine <> "" Then
        'rend invisible la biliotheque outil
        ' et visible le controle programme
        TRIPOD_SIMUL_FRM.TreeViewTOOL.Visible = False
        TRIPOD_SIMUL_FRM.Programme.Visible = True
        
            FichierIso = Chaine
            TRIPOD_SIMUL_FRM.Programme.LoadFile FichierIso
        End If
        
    
    Call TRIPOD_SIMUL_FRM.Pic_Paint
    Exit Sub
    
fin:
    MsgBox Err.Description, 16, "Error #" & Err.Number
End Sub

Sub Chargement_piece(fichier As String, Valeur_axe As Double, OriginePt As Point3)
Dim Box0 As Box3
Dim Elem_tempo As Element3D
Dim Obb_Box_tempo As OBB_box
Dim I As Integer
Dim Mere As Integer

    MessageLOG_CLS 'Rinit fentre LOG

    
    Call Reinit_Element(Piece)
    Piece.Name = ChargeFichierSTL(fichier, Piece.STL_def)
    Piece.Type_axe = 7
    Piece.Origine = OriginePt
    
    Piece.Valeur_axe = Valeur_axe
    Piece.Vecteur = Machine.Element(0).Vecteur ' La piece a le mme vecteur que l'element O
    ' element 0 de la machine = plateau
    ' test si le veceteur a une orientation
    If Longueur(Piece.Vecteur) = 0 Then
        Piece.Vecteur.Z = 1
    End If
    
    Box0 = Def_Box(Piece.STL_def)
    ReDim Piece.Obb_Col(1)
    Piece.Obb_Col(0).Pointeur_Mere = -1
    Piece.Obb_Col(0).Box_Descr = Box0
    Piece.Box_Col = Box0
    ' Stock pour la dure des modif les infos
    Obb_Box_tempo = Piece.Obb_Col(0)
    Call Creer_Obb_Box(Obb_Box_tempo, Piece, False, 0)
    'rintgre les infos  leur place
    Piece.Obb_Col(0) = Obb_Box_tempo
    'Deuxieme niveau
    For I = 1 To 8
        Obb_Box_tempo = Piece.Obb_Col(I)
        Mere = I
        Call Creer_Obb_Box(Obb_Box_tempo, Piece, True, Mere)
        Piece.Obb_Col(I) = Obb_Box_tempo
    Next I
    
    Piece_charger = True
End Sub

Sub Chargement_machine(Repertoire As String, Fichier_Def_machine As String)
Dim J As Integer
Dim xyz_ijk_lu As Interpolation
Dim retour As Boolean


If FileExists(Fichier_Def_machine) = 0 Then
    Call MessageLOG_Print("ATTENTION FICHIER INEXISTANT !!!")
    Call MessageLOG_Print(Fichier_Def_machine)
    Exit Sub
End If

'reinit les labels
    For J = 1 To 5
        TRIPOD_SIMUL_FRM.AxeDestination(J).Text = "0"
        TRIPOD_SIMUL_FRM.AxeMachine(J).Text = "0"
        Position_suivante.Join(J) = 0
        Position_precedente.Join(J) = 0
    Next
    
    
    
    
   'Charge le Machine
    Call MessageLOG_CLS

    LoadGL TRIPOD_SIMUL_FRM.Pic


    Call TRIPOD_SIMUL_FRM.Init_Machine(Repertoire, Fichier_Def_machine)
    
    Call DessineMachine(TRIPOD_SIMUL_FRM.Pic, False, 1, False, True)
    Call GetPoint
    
    Call Affiche_coord
    Call Sauvegarde_Position
    Position_Actuelle.Coord = Pt0
    
    'init piece
    For J = 1 To 16
    Piece.Matrix(J) = Machine.Element(0).Matrix(J)
    Next J
    Piece.Vecteur = Machine.Element(0).Vecteur
    If Longueur(Piece.Vecteur) = 0 Then
        Piece.Vecteur.Z = 1
    End If
 Call Initialise_Voyant
    

'
ReDim Parcours(0)

'Recuperation coordonees
TRIPOD_SIMUL_FRM.AxeDestination(1) = Machine.Pos0.X
TRIPOD_SIMUL_FRM.AxeDestination(2) = Machine.Pos0.Y
TRIPOD_SIMUL_FRM.AxeDestination(3) = Machine.Pos0.Z
TRIPOD_SIMUL_FRM.AxeDestination(4) = Machine.Or0.X
TRIPOD_SIMUL_FRM.AxeDestination(5) = Machine.Or0.Y
TRIPOD_SIMUL_FRM.AxeDestination(6) = Machine.Or0.Z

xyz_ijk_lu.Coord.X = Val(TRIPOD_SIMUL_FRM.AxeDestination(1))
xyz_ijk_lu.Coord.Y = Val(TRIPOD_SIMUL_FRM.AxeDestination(2))
xyz_ijk_lu.Coord.Z = Val(TRIPOD_SIMUL_FRM.AxeDestination(3))
xyz_ijk_lu.Pos.I = Val(TRIPOD_SIMUL_FRM.AxeDestination(4))
xyz_ijk_lu.Pos.J = Val(TRIPOD_SIMUL_FRM.AxeDestination(5))
xyz_ijk_lu.Pos.K = Val(TRIPOD_SIMUL_FRM.AxeDestination(6))


' Execute deplacement
retour = Execute_Deplacement(xyz_ijk_lu, UVW_Actuelle)
End Sub


